package triangle;

import org.junit.jupiter.api.Assertions;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;

public class TriangleTest {
	private triangle.Triangle triangle;

	@BeforeEach
	public void setUp() {
		triangle = new triangle.Triangle();
	}

	@Test
	public void testException() throws InvalidTriangleException {
		final int[] is = new int[]{1, -1, 1};
		triangle.setSides(is);
		Assertions.assertThrows(InvalidTriangleException.class, ()->triangle.getType());
	}
	
	@Test
	public void testEquilateral() throws InvalidTriangleException {
		final int[] is = new int[]{1, 1, 1};
		triangle.setSides(is);
		Assertions.assertEquals(triangle.getType(), Triangle.TriangleType.Equilateral);
	}
	
	@Test
	public void testIsosceles() throws InvalidTriangleException{
		final int[] is = new int[]{3, 3, 2};
		triangle.setSides(is);
		Assertions.assertEquals(triangle.getType(), Triangle.TriangleType.Isosceles);
	}
	
	@Test
	public void testScalene() throws InvalidTriangleException{
		final int[] is = new int[]{4, 5, 6};
		triangle.setSides(is);
		Assertions.assertEquals(triangle.getType(), Triangle.TriangleType.Scalene);
	}
	
	@Test
	public void testNat() throws InvalidTriangleException{
		final int[] is = new int[]{1, 1, 2, 5};
		triangle.setSides(is);
		Assertions.assertEquals(triangle.getType(), Triangle.TriangleType.NaT);
	}
}
