package se.liu.ida.InsuranceApp.services;




import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import se.liu.ida.InsuranceApp.data.CarData;
import se.liu.ida.InsuranceApp.data.ClientProfile;

import java.io.*;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Scanner;

@Service
public class ClientDataManagementServiceImpl implements ClientDataManagementService {
	ArrayList<ClientProfile> cp;
	private int counterId;

	@Autowired
	public ClientDataManagementServiceImpl(){
		cp = new ArrayList<>();
		retriveDataFromFile();
	}

	@Override
	public ClientProfile findById(int id) {

		// TODO Auto-generated method stub
		for (ClientProfile profile: cp) {
			System.out.println(profile.getFirstName());
			if (profile.getClientId() == id){
				return profile;
			}
		}
		return null;
	}

	@Override
	public Boolean updateClientProfile(int id, ClientProfile c) {
		for(int d = 0; d < cp.size(); d++){
			if(cp.get(d).getClientId() == id){
				cp.remove(d);
				cp.add(d, c);
				return true;
			}
		}
		return false;
	}

	@Override
	public Boolean addClientProfile(ClientProfile c){
		for (ClientProfile profile: cp) {
			if (profile.getClientId() == c.getClientId()){
				return false;
			}
		}
		counterId = c.getClientId();
		cp.add(c);
		try{
			storeDataInFile();
		}catch (Exception e){
			System.out.println(e);
			return false;
		}
		return true;
	}

	@Override
	public Boolean removeClientProfile(int id) {
		// TODO Auto-generated method stub
		for (int c = 0; c < cp.size(); c++){
			if (cp.get(c).getClientId() == id){
				cp.remove(c);
				return true;
			}
		}
		return false;
	}

	public  int getCounterId(){
		return counterId;
	}

	private void storeDataInFile() throws JSONException {
		JSONArray jsonArray = new JSONArray();
		JSONObject Item =  new JSONObject();
		for (ClientProfile profile: cp) {
			JSONObject objItem =  new JSONObject();
			objItem.put("clientId", profile.getClientId());
			objItem.put("lastName", profile.getLastName());
			objItem.put("firstName", profile.getFirstName());
			objItem.put("yearOfBirth", profile.getYearOfBirth());
			objItem.put("yearOfLicence", profile.getYearOfLicence());
			objItem.put("yearBecameClient", profile.getYearBecameClient());
			objItem.put("numberOfAccidentsThisYear", profile.getNumberOfAccidentsThisYear());
			objItem.put("yearsWithoutAccidents", profile.getYearsWithoutAccidents());
			objItem.put("goldMember", profile.getGoldMember());
			objItem.put("insuranceExpiryDate", profile.getInsuranceExpiryDate());
			JSONArray carList = new JSONArray();
			for (CarData car: profile.getCarsInsured()) {
				JSONObject cars = new JSONObject();
				cars.put("carColor", car.getCarColor());
				cars.put("yearOfProduction", car.getYearOfProduction());
				carList.put(cars);
			}
			objItem.put("carsInsured", carList);
			jsonArray.put(objItem);

		}
		Item.put("results", jsonArray);
		try (FileWriter file = new FileWriter("profileList.txt")) {
			file.write(Item.toString());
			file.flush();
		} catch(Exception e){
			System.out.println(e);
		}
	}

	public void retriveDataFromFile(){
		//JSON parser object to parse read file
		//JSONParser jsonParser = new JSONParser();

		BufferedReader in = null;
		try {
			in = new BufferedReader(
					new FileReader("profileList.txt"));
			String inputLine;
			StringBuffer response = new StringBuffer();
			while ((inputLine = in.readLine()) != null) {
				response.append(inputLine);
			} in.close();
			//System.out.println(response.toString());
			JSONObject obj = new JSONObject(response.toString());
			JSONArray JArray = obj.getJSONArray("results");

			for(int j = 0; j < JArray.length(); j++){
				JSONObject objData = JArray.getJSONObject(j);
				ClientProfile temp = new
						ClientProfile(
						Integer.parseInt(objData.getString("clientId")),
						objData.getString("lastName"),
						objData.getString("firstName"),
						Integer.parseInt(objData.getString("yearOfBirth")),
						Integer.parseInt(objData.getString("yearOfLicence")));

				temp.setYearBecameClient(Integer.parseInt(objData.getString("yearBecameClient")));
				temp.setNumberOfAccidentsThisYear(Integer.parseInt(objData.getString("numberOfAccidentsThisYear")));
				temp.setYearsWithoutAccidents(Integer.parseInt(objData.getString("yearsWithoutAccidents")));
				temp.setGoldMember(Boolean.parseBoolean(objData.getString("goldMember")));
				//temp.setInsuranceExpiryDate((Date) objData.get("insuranceExpiryDate"));

				JSONArray JArrayCars = (JSONArray) objData.get("carsInsured");
				ArrayList<CarData> carList = new ArrayList<>();
				for(int c = 0; c < JArrayCars.length(); c++){
					JSONObject objTemp = JArray.getJSONObject(c);
					CarData tempCar = new CarData(objTemp.getString("carColor"), Integer.parseInt(objTemp.getString("yearOfProduction")));
					carList.add(tempCar);
				}
				temp.setCarsInsured(carList);
				if(temp.getClientId() > counterId){
					counterId = temp.getClientId();
				}
				cp.add(temp);
			}
		} catch (IOException | JSONException e) {
			e.printStackTrace();
		}


//		try (FileReader reader = new FileReader("profileList.txt"))
//		{
//			Object obj = jsonParser.parse(reader);
//			JSONArray employeeList = (JSONArray) obj;
//			System.out.println(employeeList+"done");
//
//			//employeeList.forEach( emp -> parseEmployeeObject( (JSONObject) emp ) );
//
//		} catch (Exception e) {
//			e.printStackTrace();
//		}

//		try {
//			File myObj = new File("profileList.txt");
//			Scanner myReader = new Scanner(myObj);
//			while (myReader.hasNextLine()) {
//				String data = myReader.nextLine();
//				System.out.println(data);
//
//			}
//			myReader.close();
//		} catch (Exception e) {
//			System.out.println("An error occurred.");
//		}
	}

}
