package se.liu.ida.InsuranceApp;

import org.mockito.Mockito;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Primary;
import org.springframework.context.annotation.Profile;

import se.liu.ida.InsuranceApp.data.ClientProfile;
import se.liu.ida.InsuranceApp.services.ClientDataManagementService;
import se.liu.ida.InsuranceApp.services.InsuranceService;

@Profile("mockClientM")
@Configuration
public class MockDataTestConfig {

	@Bean
	@Primary
	public ClientDataManagementService clientDataManagementService() {
		ClientDataManagementService cs =  Mockito.mock(ClientDataManagementService.class);

		/** Add mocked behavior */
		 Mockito.when(cs.findById(1))
	       	.thenReturn(new ClientProfile(1, "Joan", "ulf", 1980, 2000));

		Mockito.when(cs.updateClientProfile(1, null))
				.thenReturn(true);

		Mockito.when(cs.addClientProfile(null))
				.thenReturn(true);

		Mockito.when(cs.removeClientProfile(1))
				.thenReturn(true);

		return cs;
	}

	@Bean
	@Primary
	public InsuranceService InsuranceService() {
		InsuranceService is =  Mockito.mock(InsuranceService.class);

		/** Add mocked behavior */
		Mockito.when(is.registerNewMember("Joan", "ulf", 1980, 2000))
				.thenReturn(true);

		Mockito.when(is.isClientGoldMember(1))
				.thenReturn(false);

		Mockito.when(is.registerNewAccident(1))
				.thenReturn(1);

		Mockito.when(is.getClientDeductible(1))
				.thenReturn(5000);

		Mockito.when(is.MonthlyInsuranceCost(1))
				.thenReturn(500);

		Mockito.when(is.addNewCarToMember(1, "Black", 2019))
				.thenReturn(true);

		Mockito.when(is.getClientProfile(1))
				.thenReturn(new ClientProfile(1, "Joan", "ulf", 1980, 2000));

		return is;
	}

}
